<?php
$postLimit = 10000;
$rowLimit = 1000;
$nameMax = 50;
$refresh = 500;
$sendOnEnter = 0;

$mode = (isset($_POST['mode']) ? $_POST['mode'] : 'page');

$c = file('data.txt');
$start = count($c) - $rowLimit;
if($start < 0) {
	$start = 0;
}
$c = implode("", array_slice($c, $start));

switch($mode) {
	case "line":
		$fp = fopen('data.txt', 'w');
		fputs($fp, $c.htmlspecialchars(substr($_POST['name'], 0, $nameMax).': '.substr($_POST['line'], 0, $postLimit)."\n"));
		fclose($fp);
	break;

	case 'c':
		echo $c;
	break;
	
	case 'page':		
		echo '
<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<title>Chat</title>
	
	<style type="text/css">
		html {
			padding: 10px;
		}
		
		* {
			font-size: 10pt;
			font-family: monospace;
		}
		
		pre {
			width: 100%;
			border: 1px solid #888;
			overflow: auto;
		}
		
		.input {
			width: 100%;
			border: 1px solid #888;
			color: #888;
		}
	</style>
</head>

<body>
	<pre id="content">'.$c.'</pre>
	<form method="post" action="index.php">
	<input type="text" id="name" name="name" value="Name" class="input"/>
	<textarea id="line" name="line" class="input" rows="5" cols="20">Message</textarea>
	<input id="post" type="button" value="Send"/>
	</form>

	<script type="text/javascript" src="//ajax.googleapis.com/ajax/libs/jquery/1.6.4/jquery.min.js"></script>
	<script type="text/javascript">
	  var sOE = ' . $sendOnEnter . ';
		$(document).ready(function() {
			$("#content").height($(window).height() * 0.85);
			
			$("#post").click(function() {
          send();
			});
			
			$("#line").keyup(function(e) {
			  if (sOE && e.which == 13) {
			    send();
			  }
			});
			
			getC(1);
			
			$(".input").focus(function(){
				if($(this).css("color") == "rgb(136, 136, 136)") {
					$(this).css("color", "rgb(0, 0, 0)").val("");
				}
			});
		});
		
		function send() {
				$.post("index.php", {"line" : $.trim($("#line").val()), "name" : $("#name").val(), "mode" : "line"});
				$("#line").focus().val("");
		}
		
		function getC(firstScroll) {
			$.post("index.php", {"mode" : "c"}, function(data) {
				$("#content").html(data);
				
				var check = $("#content").prop("scrollHeight") - $("#content").height() - 30;
				if(($("#content").prop("scrollTop") > check) || firstScroll) {
					$("#content").prop({ scrollTop: $("#content").prop("scrollHeight") });
					firstScroll = 0;
				}

				window.setTimeout("getC(0);", '.$refresh.');
			});
		}
	</script>
</body>
</html>
		';
	break;
}
